!----------------------------------------------------------------------------
! DERIVATE.R : calcola in modo numerico le derivate successive di una funzio-
! ne in un punto qualsiasi.
!----------------------------------------------------------------------------

PROGRAM DERIVATE

!$S=47104

DIM EPSILON[11],H[20],J[20],FACT[33]

FUNCTION Y(X)
  Y=X*X*X*X*-1
END FUNCTION

!$I="XT.LIB"

PROCEDURE PRESENTAZIONE
  CLS
  BLOAD(DRIVE$+"DERSUCC.BLD",0)
  REPEAT
    GET(A$)
  UNTIL A$="C" OR A$="c"
END PROCEDURE

PROCEDURE SETCONST
  DATA(0,5E-07,5E-06,5E-04,1E-03,5E-03,1E-02,5E-02,5E-02,1E-01,1.5E-01,2E-01)
  FOR I%=0 TO 11
     READ(EPSILON[I%])
  END FOR
  FACT[0]=1
  FOR I%=1 TO 33
      FACT[I%]=FACT[I%-1]*I%
  END FOR
END PROCEDURE

PROCEDURE INIT(N%->H,EPSILON)
   IF N%>3 THEN H=1
           ELSE H=0.1
   END IF
   IF N%>11 THEN EPSILON=EPSILON[11]
            ELSE EPSILON=EPSILON[N%]
   END IF
END PROCEDURE

PROCEDURE COBIN(N%,K%->BIN)
   BIN=FACT[N%]/FACT[K%]/FACT[N%-K%]
END PROCEDURE

PROCEDURE DERIV(N%,X,FLAG%,H->DER,H)
   DER=0
   FOR K%=0 TO N%
     COBIN(N%,K%->BIN)
     DER=DER+BIN*(-1)^K%*Y(X+(N%-2*K%)*H)
   END FOR
   DER=DER/(2*H)^N%
   IF FLAG% THEN PRINT("Derivata =";DER;"h= ";H) END IF
END PROCEDURE

PROCEDURE CALCOLAH(H,I%->H,I%)
   IF ABS(J[I%]-J[I%-1])>ABS(J[I%-1]-J[I%-2])
      THEN
        H=(H[I%]+H[I%-1])/2
        I%=I%-1
      ELSE
        H=H/2
   END IF
END PROCEDURE

PROCEDURE ITERA(N%,X,FLAG%,H,EPSILON)
   EX%=FALSE
   I%=0
   WHILE (I%<20) AND NOT EX%
     DERIV(N%,X,FLAG%,H->J[I%],H[I%])
     CASE I% OF
       0-> H=H/2 END ->
       1-> IF ABS(J[I%]-J[I%-1])<=EPSILON
             THEN EX%=TRUE
             ELSE H=H/2
           END IF
       END ->
       OTHERWISE
           IF ABS(J[I%]-J[I%-1])<=EPSILON
             THEN EX%=TRUE
             ELSE CALCOLAH(H,I%->H,I%)
           END IF
     END CASE
     I%=I%+1
   END WHILE
   IF NOT EX% THEN PRINT
                   PRINT("  CONVERGENZA NON RAGGIUNTA ")
                   PRINT("   ULTIMA DERIVATA =";J[I%-1])
                   PRINT("   ULTIMO H        =";H[I%-1])
              ELSE PRINT
                   PRINT("  CONVERGENZA RAGGIUNTA ")
                   PRINT("   DERIVATA =";J[I%-1])
                   PRINT("   H        =";H[I%-1])
   END IF
END PROCEDURE

PROCEDURE INPUTVALUE(->N%,X,FLAG%)
  CLS
  PRINT("Ordine della derivata ";)
  INPUT(N%)
  PRINT(" ... in che punto la calcolo ";)
  INPUT(X)
  PRINT("Vuoi i risultati parziali (s/n)";)
  INPUT(CH$)
  IF CH$="S" OR CH$="s" THEN FLAG%=TRUE
                        ELSE FLAG%=FALSE
  END IF
END PROCEDURE

BEGIN
!
!  N%      -->  ordine di derivazione
!  X       -->  punto dove calcolare
!  H       -->  usato nel calcolo della derivata approssimata
!  FLAG%   -->  flag di stampa parziale
!  EPSILON -->  approssimazione richiesta
!
DRIVE$=""
PRESENTAZIONE
SETCONST
REPEAT
   INPUTVALUE(->N%,X,FLAG%)
   INIT(N%->H,EPSILON)
   ITERA(N%,X,FLAG%,H,EPSILON)
   PRINT
   PRINT("ANCORA (S/N) ?")
   REPEAT
      GET(A$)
   UNTIL A$<>""
UNTIL A$="n" OR A$="N"
END PROGRAM
