!------------------------------------------------
! OTHELLO.R : gioca a OTHELLO contro l'operatore
!------------------------------------------------

PROGRAM OTHELLO

!$K

DIM A[200]

!$I="XT.LIB"

! *****************************************************************************
! *                                                                           *
! *   DRAWPIECES : disegna una pedina nella posizione indicata dalla varia -  *
! *                bile I                                                     *
! *                                                                           *
! *****************************************************************************

PROCEDURE DRAWPIECES
  IF I>=11 AND I<=88  THEN
     R=I\10
     C=7*(I-R*10)-2
     R=3*R-1
     CASE A[I] OF
        2-> PIECE$=""
            LOCATE(R,C)   PRINT(PIECE$;)
            LOCATE(R+1,C) PRINT(PIECE$;)
        END ->
        1-> PIECE$=""
            LOCATE(R,C)   PRINT(PIECE$;)
            LOCATE(R+1,C) PRINT(PIECE$;)
        END ->
     END CASE
  END IF
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   DRAWBOARD : disegna la scacchiera con la posizione iniziale delle pe -  *
! *               dine.                                                       *
! *                                                                           *
! *****************************************************************************

PROCEDURE DRAWBOARD
  CLS
  TOP$="ͻ"
  BOT$="ͼ"
  V$="                                                "
  H$="Ķ"
  LOCATE(1,3)
  COLOR(0,7)
  PRINT(TOP$)
  FOR J=1 TO 23
    LOCATE(J+1,3)
    IF FRC(J/3)=0 THEN PRINT(H$;) ELSE PRINT(V$;) END IF
  END FOR
  LOCATE(25,3)
  PRINT(BOT$;)
  COLOR(7,0)
  FOR I=11 TO 88
    DRAWPIECES
  END FOR
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   SITUATION : testa la scacchiera per accertare lo stato della partita.   *
! *               Se la variabile booleana OK% diventa vera la partita e'     *
! *               terminata.                                                  *
! *                                                                           *
! *****************************************************************************

PROCEDURE SITUATION(->OK%)
  OK%=FALSE
  S1=0 S2=0
  FOR I=11 TO 88
    CASE A[I] OF
      1-> S1=S1+1
      END ->
      2-> S2=S2+1
      END  ->
    END CASE
  END FOR
  LOCATE(3,65)
  PRINT(S1;"     ";S2;)
  IF S1=0 OR S2=0 OR S1+S2=64 THEN    OK%=TRUE   END IF
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   MOVECURSOR : gestisce l'input del giocatore. I tasti cursore puntano    *
! *                alla casella desiderata, RETURN convalida la scelta,       *
! *                mentre P passa e R inverte i pezzi dei due giocatori.      *
! *                                                                           *
! *****************************************************************************

PROCEDURE MOVECURSOR(->M)
  LOCATE(5,65)
  PRINT("              ";)
  FLAG%=FALSE
  REPEAT
    CURSOR(3*ROW-1,7*COL-1,1)
    GET(A$)
    CASE LEN(A$) OF
      1-> CASE A$ OF
            "R","r"-> FOR I=11 TO 88
                          IF A[I]=1 THEN A[I]=2
                                         DRAWPIECES
                                    ELSE IF A[I]=2 THEN A[I]=1
                                           DRAWPIECES
                                         END IF
                          END IF
                      END FOR
                      SOUND(2000,1)
                      FLAG%=TRUE
                      M=0  ! ribalta le pedine
            END ->
            "P","p"-> FLAG%=TRUE    M=1   ! passa la mano
            END ->
          END CASE
          IF A$=CHR$(13) THEN  M=10*ROW+COL  ! mossa di destinazione
                               CURSOR(8,65,0)
                               PRINT("              ";)
                               LOCATE(7,60)
                               PRINT("                   ";)
                               FLAG%=TRUE
          END IF
      END ->
      2-> CASE MID$(A$,2,1) OF
             "H"-> IF ROW=1 THEN ROW=8
                            ELSE ROW=ROW-1
                   END IF
             END ->
             "K"-> IF COL=1 THEN COL=8
                            ELSE COL=COL-1
                   END IF
             END ->
             "M"-> IF COL=8 THEN COL=1
                            ELSE COL=COL+1
                   END IF
             END ->
             "P"-> IF ROW=8 THEN ROW=1
                            ELSE ROW=ROW+1
                   END IF
             END ->
          END CASE
      END ->
    END CASE
  UNTIL FLAG%
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   PLAYHUMAN : controlla la validit della mossa del giocatore.            *
! *                                                                           *
! *****************************************************************************

PROCEDURE PLAYHUMAN
 REPEAT
  REPEAT
    MOVECURSOR(->M)
  UNTIL M<>0
  IF M<>1
    THEN
      B=0
      FOR K=100 TO 107
        J=M
        A=0
        TEMP%=FALSE
        REPEAT
          J=J+A[K]
          IF A[J]<1 THEN TEMP%=TRUE  EXIT  END IF
          IF A[J]=2 THEN A=A+1 ELSE EXIT END IF
        UNTIL TEMP%
        IF NOT TEMP% THEN
               I=M
               IF A<>0 THEN
                  IF A[I]<0 THEN A[I]=1 DRAWPIECES END IF
                  FOR Z1=1 TO A
                    I=I+A[K]
                    A[I]=1
                    B=B+1
                    DRAWPIECES
                  END FOR
               END IF
         END IF
     END FOR
     IF B=0 THEN LOCATE(8,65) PRINT("Mossa Illegale !") SOUND(2000,1)
      ELSE
       W=M-11
       IF W<U THEN  U=W  END IF
       WHILE A[U]=0
         U=U+1
       END WHILE
       W=M+11
       IF W>V THEN V=W END IF
       WHILE A[V]=0
         V=V-1
       END WHILE
     END IF
   ELSE
    EXIT
  END IF
 UNTIL B<>0
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   PLAYCOMPUTER : mossa del calcolatore.                                   *
! *                                                                           *
! *****************************************************************************

PROCEDURE PLAYCOMPUTER
  LOCATE(5,65)
  PRINT("Sto pensando")
  C=0  D=0
  FOR F=U TO V
    IF A[F]=0 THEN F=F+2 END IF
    IF A[F]<=0 THEN
       B=0
       FOR K=100 TO 107
         J=F A=0 TEMP%=FALSE
         REPEAT
           J=J+A[K]
           EXIT IF A[J]<1
           IF A[J]=1 THEN A=A-A[F]  ELSE  TEMP%=TRUE   END IF
         UNTIL  TEMP%
         IF TEMP% THEN B=B+A END IF
       END FOR
       IF B<>0 THEN
           IF B>C THEN C=B  A[108]=F D=1 END IF
           IF B=C THEN A[108+D]=F D=D+1 END IF
       END IF
    END IF
  END FOR
  IF C<=0 THEN  LOCATE(7,60) PRINT("Non ho mosse !") S5=1
          ELSE  I=A[107+INT(D*RND(1)+1)]
                ROW=I\10
                COL=I-ROW*10
                A[I]=2
                DRAWPIECES
                J=I
                Q=0
                FOR K=100 TO 107
                  A=0
                  I=J
                  TEMP%=FALSE
                  REPEAT
                    I=I+A[K]
                    EXIT IF A[I]<1
                    IF A[I]=2 THEN TEMP%=TRUE EXIT END IF
                    A=A+1
                  UNTIL TEMP%
                  IF TEMP% THEN I=J
                                IF A>0 THEN FOR L=1 TO A
                                              I=I+A[K]
                                              A[I]=2
                                              DRAWPIECES
                                            END FOR
                                END IF
                  END IF
                END FOR
  END IF
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   INIT : inizializza il gioco.                                            *
! *                                                                           *
! *****************************************************************************

PROCEDURE INIT
      CLS
      DATA(0,0,0,0,0,0,0,0,0,0)
      DATA(0,-99,-1,-15,-15,-15,-15,-1,-99,0)
      DATA(0,-1,-1,-5,-5,-5,-5,-1,-1,0)
      DATA(0,-15,-5,-12,-10,-10,-12,-5,-15,0)
      DATA(0,-15,-5,-10,1,2,-10,-5,-15,0)
      DATA(0,-15,-5,-10,1,2,-10,-5,-15,0)
      DATA(0,-15,-5,-12,-10,-10,-12,-5,-15,0)
      DATA(0,-1,-1,-5,-5,-5,-5,-1,-1,0)
      DATA(0,-99,-1,-15,-15,-15,-15,-1,-99,0)
      DATA(0,0,0,0,0,0,0,0,0,0)
      ROW=5 COL=5 U=33 V=66
      RESTORE
      FOR I=0 TO 99
        READ(A[I])
      END FOR
      PRINT("Chi inizia (1=IO   2=TU)";)
      INPUT(Z)
      FOR I=9 TO 12
        J=11*(I\12)
        A[91+I]=I-J
        A[95+I]=J-I
      END FOR
      DRAWBOARD
END PROCEDURE

! *****************************************************************************
! *                                                                           *
! *   PROGRAMMA PRINCIPALE : gestisce la partita.                             *
! *                                                                           *
! *****************************************************************************

BEGIN
  REPEAT
      INIT
      REPEAT
        IF Z=1 THEN PLAYCOMPUTER
               ELSE PLAYHUMAN
        END IF
        SITUATION(->OK%)
        EXIT IF OK%
        Z=3-Z    ! inverte lo status del gioco
      UNTIL FALSE
      SOUND(2000,1)
      LOCATE(1,60)
      IF S1=S2 THEN PRINT("Parit !!")
               ELSE IF S1>S2 THEN PRINT("Vinci tu !")
                             ELSE IF S1<S2 THEN PRINT("Vince il computer !!")
                                  END IF
                    END IF
      END IF
      LOCATE(10,60)
      PRINT("Giochi ancora (S/N)";)
      INPUT(M$)
  UNTIL M$<>"S" AND M$<>"s"
END PROGRAM
