!--------------------------------------------------------------------------
! POTENZE.R : calcola i coefficienti del polinomio espresso in funzione
! di n risultante dall' espressione
!
!       n   j
!         i
!      i=1
!
! Ad es. per n=2 (m=1) il sistema 
!
!   1 1   X1   1 
!       *    =   
!   2 4   X2   3  
!
!  con X1=0.5, X2=0.5
!-------------------------------------------------------------------------

PROGRAM POTENZE

DIM A[20,20]

!$D
!$I="XT.LIB"

PROCEDURE SWAP(A1,A2)
  TEMP=A2
  A2=A1
  A1=TEMP
END PROCEDURE

PROCEDURE INGRESSO(NN%)
  FOR I%=1 TO NN%
    FOR J%=1 TO NN%
      A[I%,J%]=I%^J%
    END FOR
  END FOR
END PROCEDURE

PROCEDURE TERMININOTI(NN%,MM%)
  S%=0
  FOR I%=1 TO NN%
    S%=S%+I%^MM%
    A[I%,NN%+1]=S%
  END FOR
END PROCEDURE

PROCEDURE PIVOTING(NO%,II%->PIVOT)
  IM%=II%
  PIVOT=A[II%,II%]
  FOR Z%=II% TO NO%
    IF A[Z%,II%]>PIVOT
       THEN PIVOT=A[Z%,II%]
            IM%=Z%
    END IF
  END FOR
  IF IM%<>II% THEN
              FOR W%=II% TO NO%+1
                   SWAP(A[IM%,W%],A[II%,W%])
              END FOR
  END IF
END PROCEDURE

PROCEDURE TRIANG(NN%->PM)
  FOR I%=1 TO NN%-1
    PIVOTING(NN%,I%->PM)
    IF PM<>0 THEN
             FOR K%=I%+1 TO NN%
               Q=-A[K%,I%]/A[I%,I%]
               A[K%,I%]=Q
               FOR J%=I%+1 TO NN%+1
                 A[K%,J%]=A[K%,J%]+Q*A[I%,J%]
               END FOR
             END FOR
    END IF
  END FOR
END PROCEDURE

PROCEDURE SOLVETRIANG(NN%)
   FOR I%=NN% TO 1 STEP -1
     A[I%,NN%+1]=A[I%,NN%+1]/A[I%,I%]
     IF I%<>NN% THEN
       FOR J%=I%+1 TO NN%
         A[I%,NN%+1]=A[I%,NN%+1]-A[I%,J%]*A[J%,NN%+1]/A[I%,I%]
       END FOR
     END IF
   END FOR
END PROCEDURE

PROCEDURE PRINTSOL(NN%)
  LOCATE(5,1)
  PRINT("Le soluzioni richieste sono :")
  PRINT
  FOR W%=NN% TO 1 STEP -1
    PRINT("x";W%;":=";A[W%,NN%+1])
  END FOR
END PROCEDURE

PROCEDURE GAUSS(NN%)
  TRIANG(NN%->PM)
  IF PM<>0 THEN
     SOLVETRIANG(NN%)
     PRINTSOL(NN%)
   ELSE
     LOCATE(5,1)
     PRINT("Errore nei dati !!!")
  END IF
END PROCEDURE

BEGIN

 CLS
 PRINT(TAB(20);" SOMME POLINOMIALI DI POTENZE ")
 REPEAT
  LOCATE(3,1)
  PRINT("Ordine del calcolo";)
  INPUT(M%)
 UNTIL M%>=0 OR M%<=20
 N%=M%+1
 INGRESSO(N%)
 TERMININOTI(N%,M%)
 GAUSS(N%)
 GET(CH$)
END PROGRAM
